<%--
    Copyright  2004 Sun Microsystems, Inc. All rights reserved
    Use is subject to license terms.
--%>


<%@page
import="java.io.*,javax.xml.soap.SOAPMessage,org.w3c.dom.Element,org.w3c.dom.Document,com.iplanet.am.util.XMLUtils,com.sun.identity.federation.common.FSUtils,com.sun.identity.federation.common.IFSConstants,com.sun.identity.saml.assertion.NameIdentifier,com.sun.identity.federation.message.FSNameIdentifierMappingRequest,com.sun.identity.federation.message.FSNameIdentifierMappingResponse,com.sun.identity.federation.services.FSSOAPService,com.sun.identity.federation.services.FSSession,com.sun.identity.federation.services.FSSessionManager,com.sun.identity.federation.services.FSSessionPartner,com.sun.identity.federation.services.util.FSServiceUtils,com.sun.identity.federation.services.namemapping.FSNameMappingHandler,com.sun.identity.federation.alliance.FSProviderDescriptor,com.sun.liberty.LibertyManager,com.iplanet.sso.*,com.sun.identity.saml.common.SAMLUtils" %>
<html xmlns="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<head><title>Sending NameIdentifierMappingRequest</title></head>
<%
    if (request.getMethod().equals("POST")) {

	if (FSUtils.debug.messageEnabled()) {
	    FSUtils.debug.message(
		"entering NameMappingRequester");
	}
        String metaAlias = 
	       request.getParameter(IFSConstants.META_ALIAS);
        if (metaAlias==null || metaAlias.length()==0) {
	    FSUtils.debug.message("NameMappingRequester: metaAlias=" + 
							 metaAlias);
	    %>
	       <body bgcolor="white">No MetaAlias in request. Cannot procceed.</body></html>
	    <%
            return;
        }
	String hostedProviderID =
	    LibertyManager.getProviderID(metaAlias);
	if (FSUtils.debug.messageEnabled()) {
	    FSUtils.debug.message(
		"NameMappingRequester: hostedProviderID="+
				       hostedProviderID);
	}
	SSOTokenManager manager = null;
	SSOToken ssoToken = null;
        try {
            manager = SSOTokenManager.getInstance();
            ssoToken = manager.createSSOToken(request);
            if (!manager.isValidToken(ssoToken)) {
	        %>
		    <body bgcolor="white">SSO Token is not valid.</body></html>
		<%
		return;
            }
        } catch (com.iplanet.sso.SSOException e){
	    %>
	    <body bgcolor="white">SSOException caught when trying to create
	    SSO Token from HTTP request: <%= e.getMessage() %></body></html>
	    <%
	    return;
	}

	String userDN = null;
	try {
	    userDN = ssoToken.getPrincipal().getName();
	} catch (SSOException ssoe) {
	    %>
		<body bgcolor="white"> SSOException caught when trying to
		get user DN from SSO token: <%= ssoe.getMessage() %></body></html>
	    <%
	    return;
	}
	if (FSUtils.debug.messageEnabled()) {
	    FSUtils.debug.message(
		"NameMappingRequester: userDN="+userDN);
	}	
	FSNameMappingHandler handler = new
	    FSNameMappingHandler(hostedProviderID);
	
	NameIdentifier ni = null;
	String targetNamespace =
	    request.getParameter("targetNameSpace");

	if (FSUtils.debug.messageEnabled()) {
	    FSUtils.debug.message(
		"NameMappingRequester: targetNamespace="+
		targetNamespace);
	}
	FSSessionManager sMgr =
	    FSSessionManager.getInstance(hostedProviderID);
	FSSession sess = null;
	if (sMgr != null) {
	    sess = sMgr.getSession(ssoToken);
	}

	FSSessionPartner partner = null;
	if (sess != null) {
	    partner = sess.getCurrentSessionPartner();
	}

	String remoteProviderID = null;
	if (partner != null) {
	    remoteProviderID = partner.getPartner();
	}

	if (FSUtils.debug.messageEnabled()) {
	    FSUtils.debug.message(
		"FSNameMappingRequester: remoteProviderID = " +
		remoteProviderID);
	}
	try {
	    ni = handler.getNameIdentifier(userDN,
					   remoteProviderID,
					   true);
	} catch (Exception e) {
	    %>
		<body bgcolor="white">Exception caught when trying to get Name
		Identifier for local target name space: <%= e.getMessage() %></body></html> 
	    <%
	    return;	    
	}

	if (FSUtils.debug.messageEnabled()) {
	    FSUtils.debug.message("FSNameMappingRequester: Name Identifier"+
				  " for local target name space before "+
				  "encryption = " + ni.toString());
	}
	String nameIdStr = "nothing";
	String responseStr = null;
	
	try {
	    FSProviderDescriptor hostedProviderDesc =
		FSServiceUtils.getAllianceInstance().getProvider(hostedProviderID);
	
// 	    ni.setFormat(IFSConstants.NI_FEDERATED_FORMAT_URI);

	    if (FSUtils.debug.messageEnabled()) {	
		FSUtils.debug.message(
		    "FSNameMappingRequester: Name Identifier for "+
		    "local target name space = " +ni.toString());	
	    }
	    
	    FSNameIdentifierMappingRequest mappingRequest =
		new FSNameIdentifierMappingRequest(hostedProviderID,
						   ni,
						   targetNamespace);
	    if (FSServiceUtils.isSigningOn()) {
		mappingRequest.signXML(
		    hostedProviderDesc.getSigningKeyAlias());
	    }

	    FSProviderDescriptor remoteProviderDesc =
		FSServiceUtils.getAllianceInstance().getProvider(remoteProviderID);
	    String remoteSOAPEndPoint = remoteProviderDesc.getSOAPEndPoint();

	    if (FSUtils.debug.messageEnabled()) {
		FSUtils.debug.message(
		    "FSNameMappingRequester: IDP's soap end point=" +
		    remoteSOAPEndPoint);
	    }
	    FSSOAPService soapService = FSSOAPService.getInstance();
	    SOAPMessage msg = 
		soapService.bindNameMappingRequest(mappingRequest);

	    SOAPMessage returnMsg =
		soapService.
		sendNameMappingMessage(msg, remoteSOAPEndPoint);

	    Element elt = soapService.parseSOAPMessage(returnMsg);
            FSNameIdentifierMappingResponse mappingResponse =
                new FSNameIdentifierMappingResponse(elt);

	    responseStr = mappingResponse.toXMLString();
	    
            if (FSUtils.debug.messageEnabled()) {
                FSUtils.debug.message("FSNameMappingRequester: " +
				      "NameIdentifierMappingResponse: " +
				      responseStr);
            }
	    if (FSServiceUtils.isSigningOn()) {
		if (FSNameMappingHandler.verifyNameIdMappingResponseSignature(elt, returnMsg)) {
		    if (FSUtils.debug.messageEnabled()) {
			FSUtils.debug.message(
			    "Success in verifying Name Identifier Mapping"+
			    " Response Signature");
		    }
		} else {
		    if (FSUtils.debug.messageEnabled()) {
			FSUtils.debug.message(
			    "Failed verifying Name Identifier Mapping "+
			    "Response");
		    }
		    %>
		        <body bgcolor="white">Failed verifying Name Identifier
			Mapping Response Signature</body></html>
		    <%
		    return;	    
		}
	    }

	    NameIdentifier retNI = mappingResponse.getNameIdentifier();
	    nameIdStr = retNI.toString();

	    if (FSUtils.debug.messageEnabled()) {
		FSUtils.debug.message(
		    "Received Name Identifier="+
		    nameIdStr);
	    }
	    if (retNI.getFormat() != null &&
		retNI.getFormat().equals(IFSConstants.NI_ENCRYPTED_FORMAT_URI)) {

		nameIdStr = retNI.toString(true,true);

		String decryptionURL = request.getParameter("decryptionURL");
		
		if (FSUtils.debug.messageEnabled()) {
		    FSUtils.debug.message("Decryption URL is "+
					  decryptionURL);
		}					    

		if (decryptionURL==null || decryptionURL.length()==0) {
		   %>
			Decryption URL is missing. Please fill it in.
		   <%
		   return;
                }
		%>
		    <BODY bgcolor="white" Onload="document.forms[0].submit()">
		    <H1>Response Received</H1>
			You are being redirected to the target SP for Decryption.
			Please wait ......
			<FORM METHOD="POST" ACTION="<%= decryptionURL %>">
			    <INPUT TYPE="HIDDEN" NAME="ni"
						 VALUE="<%= SAMLUtils.HTMLEncode(nameIdStr,'\"') %>">
			    <INPUT TYPE="HIDDEN" NAME="targetNameSpace"
						 VALUE="<%= targetNamespace %>">
			</FORM>
		    </BODY>
		    </html>
		<%
		return;
	    } else {

		nameIdStr = SAMLUtils.HTMLEncode(nameIdStr,'<');
                nameIdStr = SAMLUtils.HTMLEncode(nameIdStr,'>');
	
	        %>
		<body bgcolor="white"><pre>

The mapped name identifier in the target name space is:

<%= nameIdStr %>

		</pre></body></html>
		<%
		return;
	    }	
	} catch (Exception e) {
	    FSUtils.debug.error("FSNameMappingRequester: ", e);
	    %>
	    <body bgcolor="white">Got exception: <%= e.getMessage() %></body></html>
	    <%
	    return;	    
	}
    } 
%>
 
